<template>
  <single-pane>
    <ob-table
      :columns="columns"
      :functionalPanel="hasData"
      :remote-opt="{
          method: getData
        }"
      :loading="loading"
      :show-add-button="true"
      add-button-text="Добавить заменяемые ТС"
      is-fixed-header
      :tableLayoutFixed="false"
      :group-by="'group'"
      :is-functional-filter="false"
      :is-functional-group="false"
      :is-functional-sort="false"
      :isSmartPagination="false"
      groupSlotName="groupHeader"
      isGroupAction
      :groupAction="groupAction"
      @groupAction="onGroupAction"
      @add="addNewService"
      ref="servicesTable"
    >
      <template v-slot:serviceCol="{ data }">
        {{ data.item.title }}
      </template>

      <template v-slot:groupHeader="{ data }">
        <div class="group-header">
          <div class="group-header__title">
            <i class="icon truck" />
            {{ getItemTitle(data.value) }}
          </div>
          <div class="group-header__delete">
            <i
                class="icon close delete-btn"
                title="Удалить"
                @click.stop="deleteMainService(data)"
            />
          </div>
        </div>
      </template>

      <template v-slot:deleteCol="{ data }">
        <i
            class="icon close delete-btn"
            title="Удалить"
            @click="deleteReplacementService(data)"
        />
      </template>

      <template slot="noneContent">
        <div class="title">
          Сейчас список пуст<br/>
          Если хотите настроить список заменяемых ТС, нажмите “добавить”.
        </div>
        <ObButton
            label="Добавить заменяемые ТС"
            type="flat"
            data-qa="addNewService"
            @click="addNewService"
        />
      </template>
    </ob-table>

    <ob-modal
        ref="serviceReplacementModal"
        title="Заменяемые ТС"
        size="large"
        :is-show-controls="false"
    >
      <ServiceReplacementModal
          :mainUuid="mainUuidForModal"
          :replacement-uuids="[]"
          :selected-map="responseOfReplaceableServicesMap"
          @submitted="onSubmitModal"
          @close="closeModal"
      />
    </ob-modal>

    <ob-modal
        ref="deleteReplacementServiceModal"
        title="Удалить настройку заменяемости"
        size="medium"
        :is-show-controls="true"
        ok-text="Удалить"
        @submit="deleteReplacementService2"
    >
      Заменяемое ТС: {{ replacementServiceForDelete ? replacementServiceForDelete.title : '' }}
    </ob-modal>

    <ob-modal
        ref="deleteMainServiceModal"
        size="medium"
        :is-show-controls="true"
        :ok-text="`Удалить ${servicesCountInButton}`"
        @submit="deleteMainService2"
    >
      <template slot="title">
        <div class="ob-ty-modal-title">
          Удалить настройки заменяемости ТС<br/> для услуги
        </div>
      </template>

      <div class="modal-content">
        Услуга: <i class="icon truck"/> {{ getItemTitle(mainServiceForDelete) }} <br/>
        Настроек заменяемости: {{ servicesCountInModal }}
      </div>
    </ob-modal>
  </single-pane>
</template>

<script>
import api from '@/api';
import SinglePane from 'common-components/src/obComponents/obSinglePanels';
import ObTable from 'common-components/src/obComponents/obTable';
import ObButton from 'common-components/src/obComponents/obButton';
import ObModal from 'common-components/src/obComponents/obModal';
import ServiceReplacementModal from './ServiceReplacementModal'
import { plural } from "@/helpers";

  export default {
    name: 'DictionaryServiceReplacement',

    components: {
      SinglePane,
      ObTable,
      ObButton,
      ObModal,
      ServiceReplacementModal
    },

    data() {
      return {
        loading: true,
        hasData: false,
        groupAction: {
          index: 1,
          icon: 'plus',
          text: 'Добавить услугу'
        },
        servicesInfoMap: {},
        responseOfReplaceableServices: [],
        responseOfReplaceableServicesMap: {},
        mainServices: [],
        mainUuidForModal: '',
        replacementServiceForDelete: null,
        mainServiceForDelete: null,
      }
    },

    async created() {
      await this.getData();
    },

    computed: {
      columns() {
        return [
          {
            title:'',
            html:() => {
              return ''
            }
          },
          {
            title: 'Можно заменить на',
            key: 'title',
            slotName: 'serviceCol'
          },
          {
            title:'',
            slotName: 'deleteCol'
          },
        ]
      },

      groups() {
        return [...new Set(this.mainServices.map(item => {
          return {
            title: `${item.serviceTypeTitle} ${item.resourceSpeciesTitle} ${item.resourceSubtypeTitle} ${item.resourcePatternParameter}`
          }
        }))];
      },

      servicesCount() {
        return this.mainServiceForDelete
          ? this.responseOfReplaceableServices.find(item => item.mainServiceUuid === this.mainServiceForDelete.uuid)?.replacementServices.length
          : 0;
      },

      servicesCountInModal() {
        return plural(this.servicesCount, ['настройка', 'настройки', 'настроек']);
      },

      servicesCountInButton() {
        return plural(this.servicesCount, ['настройку', 'настройки', 'настроек']);
      },
    },

    methods: {
      async getData() {
        this.loading = true;
        try {
          this.responseOfReplaceableServices = await api.services.getReplaceableServices();
          this.responseOfReplaceableServicesMap = this.responseOfReplaceableServices.reduce((mainMap, mainItem) => {
            mainMap[mainItem.mainServiceUuid] = mainItem.replacementServices.reduce((replacementMap, replacementItem) => {
              replacementMap[replacementItem] = true;
              return replacementMap;
            }, {});
            return mainMap;
          }, {})

          const allUuids = this.responseOfReplaceableServices.reduce((acc, item) => {
            acc.push(item.mainServiceUuid, ...item.replacementServices);
            return acc;
          }, [])
          const servicesInfo = await api.services.getServicesAll({
            serviceUuids: Array.from(new Set(allUuids))
          });
          this.servicesInfoMap = servicesInfo.reduce((map, item) => {
            map[item.uuid] = item;
            return map;
          }, {});

          const mainServicesUuids = this.responseOfReplaceableServices.map(item => item.mainServiceUuid);
          this.mainServices = servicesInfo.filter(item => mainServicesUuids.includes(item.uuid));

          const data = this.responseOfReplaceableServices.reduce((acc, serviceCol) => {
            const group = this.servicesInfoMap[serviceCol.mainServiceUuid];
            const temp = serviceCol.replacementServices.map(replacementServiceUuid => {
              const serviceCol = this.servicesInfoMap[replacementServiceUuid];
              return {
                title: this.getItemTitle(serviceCol),
                group: group,
                uuid: serviceCol.uuid
              }
            });
            acc.push(...temp);
            return acc;
          }, []);
          this.loading = false;
          this.hasData = data.length > 0;
          return data;

        } catch (err) {
          this.loading = false;
          console.error(err);
        }
      },

      onGroupAction(event) {
        const serviceCol = event.value;
        this.mainUuidForModal = serviceCol.uuid;
        this.$refs.serviceReplacementModal.show();
      },

      getItemTitle(item) {
        return item ? `${item.serviceTypeTitle}. ${item.resourceSpeciesTitle}. ${item.resourceSubtypeTitle} ${item.resourcePatternParameter}` : '';
      },

      addNewService() {
        this.mainUuidForModal = '';
        this.$refs.serviceReplacementModal.show();
      },

      onSubmitModal() {
        this.closeModal();
        this.reloadTable();
      },

      closeModal() {
        this.$refs.serviceReplacementModal.hide();
      },

      reloadTable() {
        this.$refs.servicesTable.loadData();
      },

      deleteReplacementService(data) {
        this.replacementServiceForDelete = data.item;
        this.$refs.deleteReplacementServiceModal.open();
      },

      async deleteReplacementService2() {
        if (!this.replacementServiceForDelete) {
          console.error('No data for delete');
          this.$refs.deleteReplacementServiceModal.close();
          return;
        }

        try {
          await api.services.deleteReplaceableServices(this.replacementServiceForDelete.group.uuid, this.replacementServiceForDelete.uuid);
          this.$refs.deleteReplacementServiceModal.close();
          this.reloadTable();
        } catch (err) {
          console.error(err);
        }
      },

      deleteMainService(data) {
        this.mainServiceForDelete = data.value;
        this.$refs.deleteMainServiceModal.open();
      },

      async deleteMainService2() {
        if (!this.mainServiceForDelete) {
          console.error('No data for delete');
          this.$refs.deleteMainServiceModal.close();
          return;
        }

        try {
          await api.services.deleteReplaceableServices(this.mainServiceForDelete.uuid, null);
          this.$refs.deleteMainServiceModal.close();
          this.reloadTable();
        } catch (err) {
          console.error(err);
        }
      },
    }
  }
</script>

<style lang="scss" scoped>
.group-header {
  color: #0070a6;
  display: flex;
  flex-grow: 1;
  font-weight: 400;
  font-size: 14px;
  line-height: 20px;
  letter-spacing: .2px;

  &__title {
    align-self: center;
    flex-grow: 1;
  }

  &__delete {
    padding-right: 17px;
  }
}

.delete-btn {
  color: #D1D2D6;
  cursor: pointer;
  font-size: 24px;

  &:hover {
    color: #0070A6;
  }
}

.modal-content {
  line-height: 1.8em;

  .icon {
    color: #0070A6;
    margin-left: 5px;
  }
}
</style>


<style lang="scss">
.deleteCol {
  display: flex;
  justify-content: flex-end;
  padding-right: 13px;
  width: 100%;
}
</style>